searchData={"items":[{"type":"behaviour","title":"Extreme","doc":"TODO","ref":"Extreme.html"},{"type":"callback","title":"Extreme.connect_to_persistent_subscription/4","doc":"Spawns a persistent subscription.\n\nThe persistent subscription will send events to the `subscriber` process in\nthe form of `GenServer.cast/2`s in the shape of `{:on_event, event,\ncorrelation_id}`.\n\nSee `Extreme.PersistentSubscription` for full details.","ref":"Extreme.html#c:connect_to_persistent_subscription/4"},{"type":"callback","title":"Extreme.execute/3","doc":"TODO","ref":"Extreme.html#c:execute/3"},{"type":"callback","title":"Extreme.ping/0","doc":"Pings connected EventStore and should return `:pong` back.","ref":"Extreme.html#c:ping/0"},{"type":"callback","title":"Extreme.read_and_stay_subscribed/6","doc":"TODO","ref":"Extreme.html#c:read_and_stay_subscribed/6"},{"type":"callback","title":"Extreme.start_link/2","doc":"TODO","ref":"Extreme.html#c:start_link/2"},{"type":"callback","title":"Extreme.subscribe_to/3","doc":"TODO","ref":"Extreme.html#c:subscribe_to/3"},{"type":"callback","title":"Extreme.unsubscribe/1","doc":"TODO","ref":"Extreme.html#c:unsubscribe/1"},{"type":"type","title":"Extreme.t/0","doc":"","ref":"Extreme.html#t:t/0"},{"type":"module","title":"Extreme.ClusterConnection","doc":"Finds node in EventStore cluster that connection should be established with.","ref":"Extreme.ClusterConnection.html"},{"type":"function","title":"Extreme.ClusterConnection.gossip_with/3","doc":"","ref":"Extreme.ClusterConnection.html#gossip_with/3"},{"type":"module","title":"Extreme.Configuration","doc":"Set of functions for retrieving configuration value with correct type","ref":"Extreme.Configuration.html"},{"type":"function","title":"Extreme.Configuration.get_connection_name/1","doc":"Returns `:connection_name` from `configuration` as binary.\nIf one is not specified defaults to \"Extreme\".","ref":"Extreme.Configuration.html#get_connection_name/1"},{"type":"function","title":"Extreme.Configuration.get_node/1","doc":"","ref":"Extreme.Configuration.html#get_node/1"},{"type":"function","title":"Extreme.Configuration.prepare_credentials/1","doc":"Returns credentials part of EventStore request based on `:username` and `:password`\nfields in `configuration`. In any of those is not specified raises exception.","ref":"Extreme.Configuration.html#prepare_credentials/1"},{"type":"module","title":"Extreme.Connection","doc":"","ref":"Extreme.Connection.html"},{"type":"function","title":"Extreme.Connection.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extreme.Connection.html#child_spec/1"},{"type":"function","title":"Extreme.Connection.push/2","doc":"","ref":"Extreme.Connection.html#push/2"},{"type":"function","title":"Extreme.Connection.start_link/2","doc":"","ref":"Extreme.Connection.html#start_link/2"},{"type":"module","title":"Extreme.Connection.State","doc":"","ref":"Extreme.Connection.State.html"},{"type":"module","title":"Extreme.ConnectionImpl","doc":"Set of connection related functions meant to be used from `Extreme.Connection` only!","ref":"Extreme.ConnectionImpl.html"},{"type":"function","title":"Extreme.ConnectionImpl.execute/2","doc":"","ref":"Extreme.ConnectionImpl.html#execute/2"},{"type":"function","title":"Extreme.ConnectionImpl.receive_package/2","doc":"","ref":"Extreme.ConnectionImpl.html#receive_package/2"},{"type":"module","title":"Extreme.FanoutListener","doc":"Module that uses this listener will connect to stream of event store and wait for new events.\nIn the contrast of Extreme.Listener which will first read existing events (starting from position x) and then\nkeep listening new events.\n\nThis is similar behavior as RabbitMQs fanout exchenge, hence the name.\n\nIt's not uncommon situation to listen live events and propagate them (for example on web sockets).\nFor that situation there is Extreme.FanoutListener macro that hides noise from listener:\n\n    defmodule MyApp.MyFanoutListener do\n      use Extreme.FanoutListener\n      import MyApp.MyPusher\n\n      defp process_push(push) do\n        Logger.info \"Forward to web socket event #{inspect push.event.event_type}\"\n        :ok = push.event.data\n               |> :erlang.binary_to_term\n               |> process_event(push.event.event_type)\n      end\n    end\n\n    defmodule MyApp.MyPusher do\n      def process_event(data, \"Elixir.MyApp.Events.PersonCreated\") do\n        Logger.debug \"Transform and push event with data: #{inspect data}\"\n        :ok\n      end\n      def process_event(_, _), do: :ok # Just acknowledge events we are not interested in\n    end\n\nListener can be started manually but it is most common to place it in supervisor AFTER specifing Extreme:\n\n    defmodule MyApp.Supervisor do\n      use Supervisor\n\n      def start_link, do: Supervisor.start_link __MODULE__, :ok\n\n      @event_store MyApp.EventStore\n\n      def init(:ok) do\n        event_store_settings = Application.get_env :my_app, :event_store\n\n        children = [\n          supervisr(MyExtreme, [event_store_settings]),\n          worker(MyApp.MyFanoutListener, [MyExtreme, \"my_indexed_stream\", [name: MyFanoutListener]]),\n          # ... other workers / supervisors\n        ]\n        supervise children, strategy: :one_for_one\n      end\n    end\n\nListener can temporary unsubscribe from stream:\n\n    :ok = MyApp.MyFanoutListener.unsubscribe(MyFanoutListener)\n\n... and resubscribe again:\n\n    :ok = MyApp.MyFanoutListener.resubscribe(MyFanoutListener)","ref":"Extreme.FanoutListener.html"},{"type":"module","title":"Extreme.Listener","doc":"TODO","ref":"Extreme.Listener.html"},{"type":"module","title":"Extreme.MessageResolver","doc":"","ref":"Extreme.MessageResolver.html"},{"type":"function","title":"Extreme.MessageResolver.decode_cmd/1","doc":"","ref":"Extreme.MessageResolver.html#decode_cmd/1"},{"type":"function","title":"Extreme.MessageResolver.encode_cmd/1","doc":"","ref":"Extreme.MessageResolver.html#encode_cmd/1"},{"type":"module","title":"Extreme.Messages","doc":"Messages are based on  official proto file: \nhttps://github.com/EventStore/EventStore/blob/master/src/Protos/ClientAPI/ClientMessageDtos.proto\n+ ReadStreamEventsBackward message (that works but is missing in their proto file)","ref":"Extreme.Messages.html"},{"type":"function","title":"Extreme.Messages.defs/0","doc":"","ref":"Extreme.Messages.html#defs/0"},{"type":"module","title":"Extreme.PersistentSubscription","doc":"An asynchronous subscription strategy.\n\nOther subscription methods require stream positions to be persisted by the\nclient (e.g. in `:dets` or PostgreSQL). Persistent Subscription is a\nsubscription strategy in which details about backpressure, buffer sizes, and\nstream positions are all held by the EventStore (server).\n\nIn a persistent subscription, all communication is asynchronous. When an\nevent is received and processed, it must be acknowledged as processed by\n`ack/3` in order to be considered by the server as processed. The server\nstores knowledge of which events have been processed by means of checkpoints,\nso listeners which use persistent subscriptions do not store stream positions\nthemselves.\n\nThe system of `ack/3`s and `nack/5`s allows listeners to handle events in\nunconventional ways:\n\n* concurrent processing: events may be handled by multiple processors at the\n  same time.\n* out of order processing: events may be handled in any order.\n* retry: events which are `nack/5`-ed with the `:retry` action, and events\n  which do not receive acknowledgement via `ack/3` are retried.\n* message parking: if an event is not acknowledged and reaches its maximum\n  retry count, the message is parked in a parked messages queue. This\n  prevents head-of-line blocking typical of other subscription patterns.\n* competing consumers: multiple consumers may process events without\n  collaboration or gossip between the consumers themselves.\n\nPersistent subscriptions are started with\n`c:Extreme.connect_to_persistent_subscription/4` expect a `cast` of each event\nin the form of `{:on_event, event, correlation_id}`\n\nA Persistent Subscription must exist before it can be connected to.\nPersistent Subscriptions can be created by sending the\n`Extreme.Messages.CreatePersistentSubscription` message via\n`c:Extreme.execute/3`, by the HTTP API, or in the EventStore dashboard.","ref":"Extreme.PersistentSubscription.html"},{"type":"module","title":"Example - Extreme.PersistentSubscription","doc":"```elixir\ndefmodule MyPersistentListener do\n  use GenServer\n\n  alias Extreme.PersistentSubscription\n\n  def start_link(opts) do\n    GenServer.start_link(__MODULE__, opts)\n  end\n\n  def init(opts) do\n    {:ok, opts}\n  end\n\n  def subscribe(listener_proc), do: GenServer.cast(listener_proc, :subscribe)\n\n  def handle_cast(:subscribe, state) do\n    {:ok, subscription_pid} =\n      MyExtremeClientModule.connect_to_persistent_subscription(\n        self(),\n        opts.stream,\n        opts.group,\n        opts.allowed_in_flight_messages\n      )\n\n    {:noreply, Map.put(state, :subscription_pid, subscription_pid)}\n  end\n\n  def handle_cast({:on_event, event, correlation_id}, state) do\n    # .. do the real processing here ..\n\n    :ok = PersistentSubscription.ack(state.subscription_pid, event, correlation_id)\n\n    {:noreply, state}\n  end\n\n  def handle_call(:unsubscribe, _from, state) do\n    :unsubscribed = MyExtremeClientModule.unsubscribe(state.subscription_pid)\n\n    {:reply, :ok, state}\n  end\n\n  def handle_info(_, state), do: {:noreply, state}\nend\n```","ref":"Extreme.PersistentSubscription.html#module-example"},{"type":"function","title":"Extreme.PersistentSubscription.ack/3","doc":"Acknowledges that an event or set of events have been successfully processed.\n\n`ack/3` takes any of the following for event ID:\n\n* a full event, as given in the `{:on_event, event, correlation_id}` cast\n* the `event_id` of an event (either from its `:link` or `:event`, depending\n  on if the event comes from a projection or a normal stream, respectively)\n* a list of either sort\n\n`correlation_id` comes from the `:on_event` cast.","ref":"Extreme.PersistentSubscription.html#ack/3"},{"type":"function","title":"Example - Extreme.PersistentSubscription.ack/3","doc":"def handle_cast({:on_event, event, correlation_id}, state) do\n      # .. do some processing ..\n\n      # when the processing completes successfully:\n      :ok = Extreme.PersistentSubscription.ack(state.subscription_pid, event, correlation_id)\n\n      {:noreply, state}\n    end","ref":"Extreme.PersistentSubscription.html#ack/3-example"},{"type":"function","title":"Extreme.PersistentSubscription.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extreme.PersistentSubscription.html#child_spec/1"},{"type":"function","title":"Extreme.PersistentSubscription.nack/5","doc":"Acknowledges that an event or set of events could not be handled.\n\nSee `ack/3` for information on `event` and `correlation_id`.\n\n`action` can be any of the following\n\n* `:unknown`\n* `:park`\n* `:retry`\n* `:skip`\n* `:stop`\n\nThe `:park` action sets aside the event in the Parked Messages queue, which\nmay be replayed via [the HTTP\nAPI](https://eventstore.com/docs/http-api/competing-consumers/index.html#replaying-parked-messages)\nor by button click in the EventStore Persistent Subscriptions dashboard.\n\nWhen an event reaches the max retry count configured by the\n`:max_retry_count` field in `Extreme.Messages.CreatePersistentSubscription`,\nthe event is parked.","ref":"Extreme.PersistentSubscription.html#nack/5"},{"type":"function","title":"Example - Extreme.PersistentSubscription.nack/5","doc":"def handle_cast({:on_event, event, correlation_id}, state) do\n      # .. do some processing ..\n\n      # in the case that the processing fails and should be retried:\n      :ok = Extreme.PersistentSubscription.nack(state.subscription_pid, event, correlation_id, :retry)\n\n      {:noreply, state}\n    end","ref":"Extreme.PersistentSubscription.html#nack/5-example"},{"type":"type","title":"Extreme.PersistentSubscription.event/0","doc":"An event received from a persistent subscription.","ref":"Extreme.PersistentSubscription.html#t:event/0"},{"type":"type","title":"Extreme.PersistentSubscription.event_id/0","doc":"An event ID.\n\nEither from the `:link` or `:event`, depending on if the event is from a\nprojection stream or a normal stream (respectively).","ref":"Extreme.PersistentSubscription.html#t:event_id/0"},{"type":"module","title":"Extreme.ReadingSubscription","doc":"","ref":"Extreme.ReadingSubscription.html"},{"type":"function","title":"Extreme.ReadingSubscription.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extreme.ReadingSubscription.html#child_spec/1"},{"type":"function","title":"Extreme.ReadingSubscription.start_link/4","doc":"Spawns Subscription for read_and_stay_subscribed","ref":"Extreme.ReadingSubscription.html#start_link/4"},{"type":"module","title":"Extreme.ReadingSubscription.State","doc":"","ref":"Extreme.ReadingSubscription.State.html"},{"type":"module","title":"Extreme.Request","doc":"","ref":"Extreme.Request.html"},{"type":"function","title":"Extreme.Request.prepare/2","doc":"","ref":"Extreme.Request.html#prepare/2"},{"type":"function","title":"Extreme.Request.prepare/3","doc":"","ref":"Extreme.Request.html#prepare/3"},{"type":"module","title":"Extreme.RequestManager","doc":"","ref":"Extreme.RequestManager.html"},{"type":"function","title":"Extreme.RequestManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extreme.RequestManager.html#child_spec/1"},{"type":"function","title":"Extreme.RequestManager.connect_to_persistent_subscription/5","doc":"","ref":"Extreme.RequestManager.html#connect_to_persistent_subscription/5"},{"type":"function","title":"Extreme.RequestManager.execute/4","doc":"","ref":"Extreme.RequestManager.html#execute/4"},{"type":"function","title":"Extreme.RequestManager.identify_client/2","doc":"Send IdentifyClient message to EventStore. Called when connection is established.","ref":"Extreme.RequestManager.html#identify_client/2"},{"type":"function","title":"Extreme.RequestManager.kill_all_subscriptions/1","doc":"","ref":"Extreme.RequestManager.html#kill_all_subscriptions/1"},{"type":"function","title":"Extreme.RequestManager.ping/2","doc":"","ref":"Extreme.RequestManager.html#ping/2"},{"type":"function","title":"Extreme.RequestManager.process_server_message/2","doc":"Processes server message as soon as it is completely received via tcp.\nThis function is run in `connection` process.","ref":"Extreme.RequestManager.html#process_server_message/2"},{"type":"function","title":"Extreme.RequestManager.read_and_stay_subscribed/3","doc":"","ref":"Extreme.RequestManager.html#read_and_stay_subscribed/3"},{"type":"function","title":"Extreme.RequestManager.respond_with_server_message/3","doc":"Sends `message` as a response to pending request or as a push on subscription.\n`correlation_id` is used to find pending request/subscription.","ref":"Extreme.RequestManager.html#respond_with_server_message/3"},{"type":"function","title":"Extreme.RequestManager.send_heartbeat_response/2","doc":"","ref":"Extreme.RequestManager.html#send_heartbeat_response/2"},{"type":"function","title":"Extreme.RequestManager.start_link/2","doc":"","ref":"Extreme.RequestManager.html#start_link/2"},{"type":"function","title":"Extreme.RequestManager.subscribe_to/5","doc":"","ref":"Extreme.RequestManager.html#subscribe_to/5"},{"type":"module","title":"Extreme.RequestManager.State","doc":"","ref":"Extreme.RequestManager.State.html"},{"type":"module","title":"Extreme.Response","doc":"","ref":"Extreme.Response.html"},{"type":"function","title":"Extreme.Response.get_correlation_id/1","doc":"","ref":"Extreme.Response.html#get_correlation_id/1"},{"type":"function","title":"Extreme.Response.parse/1","doc":"","ref":"Extreme.Response.html#parse/1"},{"type":"function","title":"Extreme.Response.reply/2","doc":"","ref":"Extreme.Response.html#reply/2"},{"type":"module","title":"Extreme.SharedSubscription","doc":"This module contains functions shared between `Extreme.Subscription` and `Extreme.ReadingSubscription`.","ref":"Extreme.SharedSubscription.html"},{"type":"function","title":"Extreme.SharedSubscription.on_event/3","doc":"Calls subscriber with {:on_event, event}, expecting :ok as result\nin order to apply backpressure.","ref":"Extreme.SharedSubscription.html#on_event/3"},{"type":"function","title":"Extreme.SharedSubscription.process_push/2","doc":"Executes `fun` function for decoding response and responds on that message.","ref":"Extreme.SharedSubscription.html#process_push/2"},{"type":"function","title":"Extreme.SharedSubscription.subscribe/1","doc":"Sends subscription request and waits for positive response. Returns `{:ok, subscription_confirmation}`.","ref":"Extreme.SharedSubscription.html#subscribe/1"},{"type":"function","title":"Extreme.SharedSubscription.unsubscribe/2","doc":"Sends unsubscribe request and remembers who it should respond to when response is received.\nResponse will arrive to subscription as push message.","ref":"Extreme.SharedSubscription.html#unsubscribe/2"},{"type":"module","title":"Extreme.Subscription","doc":"","ref":"Extreme.Subscription.html"},{"type":"function","title":"Extreme.Subscription.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extreme.Subscription.html#child_spec/1"},{"type":"function","title":"Extreme.Subscription.start_link/6","doc":"","ref":"Extreme.Subscription.html#start_link/6"},{"type":"function","title":"Extreme.Subscription.unsubscribe/1","doc":"Calls `server` with :unsubscribe message. `server` can be either `Subscription` or `ReadingSubscription`.","ref":"Extreme.Subscription.html#unsubscribe/1"},{"type":"module","title":"Extreme.Subscription.State","doc":"","ref":"Extreme.Subscription.State.html"},{"type":"module","title":"Extreme.SubscriptionsSupervisor","doc":"","ref":"Extreme.SubscriptionsSupervisor.html"},{"type":"function","title":"Extreme.SubscriptionsSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extreme.SubscriptionsSupervisor.html#child_spec/1"},{"type":"function","title":"Extreme.SubscriptionsSupervisor.init/1","doc":"","ref":"Extreme.SubscriptionsSupervisor.html#init/1"},{"type":"function","title":"Extreme.SubscriptionsSupervisor.kill_all_subscriptions/1","doc":"","ref":"Extreme.SubscriptionsSupervisor.html#kill_all_subscriptions/1"},{"type":"function","title":"Extreme.SubscriptionsSupervisor.start_link/1","doc":"","ref":"Extreme.SubscriptionsSupervisor.html#start_link/1"},{"type":"function","title":"Extreme.SubscriptionsSupervisor.start_persistent_subscription/6","doc":"","ref":"Extreme.SubscriptionsSupervisor.html#start_persistent_subscription/6"},{"type":"function","title":"Extreme.SubscriptionsSupervisor.start_subscription/4","doc":"","ref":"Extreme.SubscriptionsSupervisor.html#start_subscription/4"},{"type":"function","title":"Extreme.SubscriptionsSupervisor.start_subscription/6","doc":"","ref":"Extreme.SubscriptionsSupervisor.html#start_subscription/6"},{"type":"module","title":"Extreme.Supervisor","doc":"","ref":"Extreme.Supervisor.html"},{"type":"function","title":"Extreme.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extreme.Supervisor.html#child_spec/1"},{"type":"function","title":"Extreme.Supervisor.start_link/2","doc":"","ref":"Extreme.Supervisor.html#start_link/2"},{"type":"module","title":"Extreme.Tcp","doc":"Set of functions for TCP communication.","ref":"Extreme.Tcp.html"},{"type":"function","title":"Extreme.Tcp.connect/4","doc":"Opens tcp connection with EventStore. Returns `{:ok, socket}` on success or\n`{:error, :max_attempt_exceeded}` if connection wasn't made in `:max_attempts`\nprovided in `configuration`. If not specified, `max_attempts` defaults to :infinity","ref":"Extreme.Tcp.html#connect/4"},{"type":"module","title":"Extreme.Tools","doc":"Set of tool functions for internal library use.","ref":"Extreme.Tools.html"},{"type":"function","title":"Extreme.Tools.cast_to_atom/1","doc":"Cast the provided value to an atom if appropriate.\nIf the provided value is a string, convert it to an atom, otherwise return it as-is.","ref":"Extreme.Tools.html#cast_to_atom/1"},{"type":"function","title":"Extreme.Tools.cast_to_integer/1","doc":"Converts value to integer if it is binary or returns it as-is","ref":"Extreme.Tools.html#cast_to_integer/1"},{"type":"function","title":"Extreme.Tools.generate_uuid/0","doc":"Generates new UUID1 as binary.","ref":"Extreme.Tools.html#generate_uuid/0"}],"content_type":"text/markdown"}